/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * SetResultFieldMScriptFunction.java
 *
 * Created on 30 August 2007 Thursday, 11:34
 *
 */

package org.moremotion.mmcomp.ajax;

import java.util.HashMap;
import org.moremotion.evaluator.EvaluationException;
import org.moremotion.evaluator.Expression;
import org.moremotion.evaluator.MMSymbolResolver;
import org.moremotion.evaluator.MScriptFunction;
import org.moremotion.evaluator.MScriptFunctionContext;
import org.moremotion.evaluator.MScriptFunctionException;
import org.moremotion.servlet.MoreMotionRequest;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: SetResultFieldMScriptFunction.java 51 2008-03-10 11:46:54Z erkan $
 */
public class SetResultFieldMScriptFunction implements MScriptFunction {
  
  
  public Object execute(Expression[] params, MScriptFunctionContext msfc) throws MScriptFunctionException {
    
    if (params.length < 2) {
      throw new MScriptFunctionException("LESS_PARAMETERS_THAN_EXPECTED",new String[]{"setResultField()"},null);
    }
    
    try {
      
      MMSymbolResolver sr = msfc.getSymbolResolver();
      String fieldName = params[0].toString();
      String fieldValue = params[1].evaluate(sr).toString();
      
      MoreMotionRequest request = msfc.getRequest();
      HashMap resultFields = (HashMap)request.getAttribute("ajax.result.fields");
      if (resultFields == null) {
        resultFields = new HashMap();
        request.setAttribute("ajax.result.fields",resultFields);
      }
      resultFields.put(fieldName,fieldValue);
      
      return "\5";
      
    } catch (EvaluationException ex) {
      throw new MScriptFunctionException(ex);
    }
    
  }

}
