/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */
package org.moremotion.mmcomp.mailer;

import javax.mail.Session;
import javax.mail.Transport;
import org.moremotion.util.Logger;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: ForegroundMailer.java 51 2008-03-10 11:46:54Z erkan $
 */
public class ForegroundMailer {
  
  public static void send(MailTask mtask, Logger logger) throws Exception {
    Session ses = mtask.getSession();
    Transport trans = ses.getTransport();
    trans.connect();
    
    while(true) { 
      boolean listComplete = mtask.getEntriesComplete();
      MailEntry me = mtask.getNextEntryToProcess(); 
      if (me == null && listComplete) break;
      try {
        if (mtask.getHtmlMail()) {
          if (logger.LEVEL1) logger.printres("HTML_MAILER_UNAVAILABLE");
        } else {
          TextMailSender.send(ses,trans,mtask,me,"Foreground Mailer");
        }
      } catch(Exception e) {
        try {
          if (trans != null) trans.close();
        } catch (Exception ignore){}
        e.printStackTrace();
        throw e;
      }
    }
    trans.close();
    
  }
  
}
