/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * MailAddress.java
 *
 * Created on 02 November 2005 Wednesday, 22:42
 */

package org.moremotion.mmcomp.mailer;

import java.util.LinkedList;
import javax.mail.internet.InternetAddress;
import org.moremotion.util.StringParser;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: MailAddress.java 51 2008-03-10 11:46:54Z erkan $
 */
public class MailAddress {
  
  LinkedList invalids = null;
  InternetAddress[] ias = null;
  
  /** Creates a new instance of MailAddress */
  public MailAddress(String adresses) {
    
    LinkedList valids = new LinkedList();
    StringParser parser = new StringParser(adresses,',');
    while (!parser.eos()) {
      String s = parser.nextItem();
      try {
        InternetAddress a = new InternetAddress(s);
        valids.addLast(a);
      } catch (Exception e) {
        if (invalids == null) invalids = new LinkedList();
        invalids.addLast(s);
      }
    }
    
    if (valids.size() > 0) {
      ias = new InternetAddress[valids.size()];
      valids.toArray(ias);
    }
    
  }
   
  public boolean hasValidAddress() {
    return ias != null;
  }
  
  public InternetAddress[] getAddresses() {
    return this.ias;
  }
  
  public String[] getValids() {
    if (ias == null) {
      return new String[0];
    }
    String[] result = new String[ias.length];
    for (int i = 0; i < this.ias.length; i++) {
      result[i] = ias[i].getAddress();
    }
    return result;
  }
  
  public String[] getInvalids() {
    if (invalids == null) {
      return new String[0];
    }
    String[] result = new String[invalids.size()];
    invalids.toArray(result);
    return result;
  }
  

}
