/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * FastMetaData.java
 *
 * Created on 02 November 2005 Wednesday, 19:25
 */

package org.moremotion.mmcomp.reldb;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.Locale;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: FastMetaData.java 215 2008-09-13 10:27:24Z erkan $
 */
public class FastMetaData {
  
  private String[] name;
  private String[] type;
  private boolean[] goodForXml;
  private boolean[] isClob;
  private int count;
  
  public int columnCount() {
    return count;
  }
  
  public String name(int index) {
    return name[index-1];
  }
  
  public String type(int index) {
    return type[index-1];
  }
  
  public boolean goodForXml(int index) {
    return goodForXml[index-1];
  }
  
  public boolean isClob(int index) {
    return isClob[index-1];
  }
  
  public FastMetaData(ResultSet rs) throws Exception {
    
    Locale enLocale = new Locale("en");
    
    ResultSetMetaData rsmd = rs.getMetaData();
    count = rsmd.getColumnCount();
    name = new String[count];
    type = new String[count];
    goodForXml = new boolean[count];
    isClob = new boolean[count];
    
    int j = -1;
    for (int i = 1; i <= count; i++) {
      j++;
      String tn = rsmd.getColumnTypeName(i).toUpperCase(enLocale);
      name[j] = rsmd.getColumnName(i);
      type[j] = tn;
      
      if (tn.indexOf("BLOB") > -1 || tn.indexOf("MAGE") > -1) {
        goodForXml[j] = false;
      } else {
        goodForXml[j] = true;
        if (tn.equals("CLOB")) isClob[j] = true; else isClob[j] = false;
      }
    }
  }
  
}
