/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */


package org.moremotion.mmcomp.utils;

import org.moremotion.adom.ADOM;
import org.moremotion.adom.ADOMNode;
import org.moremotion.datasrc.DataService;
import org.moremotion.datasrc.DataServiceContext;
import org.moremotion.servlet.MoreMotionRequest;
import org.moremotion.servlet.ServiceException;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: EmptyNodesDataService.java 51 2008-03-10 11:46:54Z erkan $
 */
public class EmptyNodesDataService implements DataService {
  
  public void doService(ADOM adom, DataServiceContext dsc) throws ServiceException {
    
    adom.clear();
    
    MoreMotionRequest request = dsc.getRequest();
    int count = dsc.getDataSourceConfig().getParameter("nodeAmount").resolve(request).intValue(0);
    
    ADOMNode rootNode = adom;
    for (int i = 0; i < count; i++) {
      rootNode.addNode(new ADOMNode("item"));
    }
  }
  
}
