/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * ExternalXmlDataService.java
 *
 * Created on January 25, 2002, 4:25 PM
 */

package org.moremotion.mmcomp.utils;

import org.moremotion.adom.ADOM;
import org.moremotion.datasrc.DataService;
import org.moremotion.datasrc.DataServiceContext;
import org.moremotion.datasrc.DataSourceConfig;
import org.moremotion.page.PageUtils;
import org.moremotion.servlet.MoreMotionRequest;
import org.moremotion.servlet.ServiceException;


/**
 * Connets an XML source over HTTP and fills in the given{@link org.moremotion.adom.ADOM ADOM}
 * object with the acquired data.
 *
 * @author Yusuf Boyacigil
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: ExternalXmlDataService.java 148 2008-06-10 17:03:26Z erkan $
 */ 
public class ExternalXmlDataService implements DataService {
  
  
  public void doService(ADOM adom, DataServiceContext dsc) throws ServiceException {
    
    adom.clear();
    MoreMotionRequest request = dsc.getRequest();
    DataSourceConfig dsconfig = dsc.getDataSourceConfig();
    
    try {
      
      ExternalXml exml = new ExternalXml(dsconfig, request, dsc.logger);

      adom.setXmlExplicit(exml.getXml());
      
    } catch(Exception e) {
      String trace = org.moremotion.exception.ExceptionUtils.getStackTrace(e);
      trace = PageUtils.encodeXMLElementValue(trace);
      adom.setXmlExplicit("<exception-trace>"+trace+"</exception-trace>");
    }
    
  }
  

  
  
}