/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * ConditionalListIterator.java
 *
 */

package org.moremotion.config;

import org.moremotion.servlet.MoreMotionRequest;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: ConditionalListIterator.java 51 2008-03-10 11:46:54Z erkan $
 */
public class ConditionalListIterator {
  
  private int index = -1;
  private MoreMotionRequest request;
  private ConditionalList clist;
  
  /**
   * Creates a new instance of ConditionalListIterator
   */
  protected ConditionalListIterator(ConditionalList clist, MoreMotionRequest request) {
    this.clist = clist;
    this.request = request;
  }
  
  public boolean hasMore() throws ConfigParameterException {
    return clist.nextItemIndex(request,index + 1) != -1;
  }
  
  public ConditionalListItem next() throws ConfigParameterException {
    index = clist.nextItemIndex(request,++index);
    if (index > -1) {
      return clist.get(index);
    }
    
    return null;
  }
  
  
}
