/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * ADOMName.java
 *
 * Created on 07 February 2006 Tueasday, 16:55
 */

package org.moremotion.evaluator;

import org.moremotion.adom.ADOMUtils;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: ADOMName.java 51 2008-03-10 11:46:54Z erkan $
 */
public class ADOMName extends Symbol {
  
  private String str;
  
  /** Creates a new instance of ADOMName */
  public ADOMName(String str) { 
    super(str);
    this.str = str;
  }
  
  public char getScope() {
    return ADOMUtils.getADOMScope(this.str);
  }
  
  public String getName() {
    return ADOMUtils.getPureADOMName(this.str);
  }
  
  public Object evaluate(SymbolResolver sr) {  
    return this.str;
  }
  
  public String toString() {
    return this.str;
  }
  
}
