/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * Keys.java
 *
 * Created on January 10, 2002, 11:34 AM
 */

package org.moremotion.evaluator;

import java.util.ArrayList;
import java.util.HashMap;

import org.moremotion.util.StringParser;

/**
 * @author  Mehmet Tastan
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: Keys.java 51 2008-03-10 11:46:54Z erkan $
 */
public class Keys /* implements Operator */ {
  
  private static HashMap keysList = new HashMap();
  
  ArrayList or = new ArrayList();
  ArrayList in = new ArrayList();
  ArrayList out = new ArrayList();
  
  /** Creates new Keys */
  private Keys(String str) {
    StringParser p = new StringParser(str,' ');
    p.trimmed();
    while (p.hasMore()) {
      String s = p.nextItem().toUpperCase();
      if (s.length() > 0) {
        if (s.charAt(0) == '+') in.add(s.substring(1));
        else if (s.charAt(0) == '-') out.add(s.substring(1));
        else or.add(s);
      }
    }
  }
  
  private boolean includes(String fld, String val){
    return fld.indexOf(val) > -1;
  }
  
  public boolean includedIn(String field) {
    field = field.toUpperCase();
    String word;
    if (in.size() == 0 && out.size() == 0){
      if (or.size() == 0) return false; //hic kelime yok. False
      for (int i = 0; i < or.size(); i++){
        if ( includes(field,(String) or.get(i)) ) {
          return true; // Bir tanesi bulundu, dogru donder
        }
      }
      return false; //Sadece "OR" var ve hic bir tanesi bulunmadi
    }
    
    for (int i=0; i<in.size(); i++) {
      if (!includes(field, (String) in.get(i))){
        return false; //Olmasi gerekenlerden bir tanesi bulunamadi. Yanlis donder
      }
    }
    
    for (int i=0; i<out.size(); i++) {
      if (includes(field, (String) out.get(i))){
        return false; //Olmamasi gerekenlerden bir tanesi bulunamadi. Yanlis donder
      }
    }
    
    return true;
  }
  
  public static Keys keys(String tokens) {
    Keys keys = (Keys) keysList.get(tokens);
    if (keys != null) {
      return keys;
    }
    keys = new Keys(tokens);
    keysList.put(tokens,keys);
    if (keysList.size() > 200) {
      keysList.clear(); // Free memory
    }
    return keys;
  }
  
}
