/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * WildCard.java
 *
 * Created on 28 July 2005 Thursday, 16:56
 */

package org.moremotion.evaluator;

import org.moremotion.util.XString;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: WildCard.java 51 2008-03-10 11:46:54Z erkan $
 */

public class WildCard {
  
  String pattern = null;
  
  /** Creates a new instance of WildCard */
  public WildCard(String pattern) {
    this.pattern = pattern;
  }
  
  public boolean match(String str) {
    if (pattern.equals("*")) {
      return true;
    }
    pattern = XString.replace(pattern, "**",  "*");
    StringBuffer p = new StringBuffer(pattern);
    StringBuffer s = new StringBuffer(str);
    
    int i = 0;
    int j = 0;
    
    while (i < p.length() && j < s.length()) {
      if (p.charAt(i) == '*') {
        
        i++;
        char c = p.charAt(i);
        while (j < s.length() && c != s.charAt(j))
          j++;
      } else {
        if (p.charAt(i) != s.charAt(j)) {
          return false;
        }
        i++;
        j++;
      }
      if (i+1 == p.length() && p.charAt(i) == '*') {
        return true;
      }
    }
    
    return i == p.length() && j == s.length();
    
  }
  
  public static void main(String[] args) throws Exception{
    
    WildCard wc = new WildCard("aaa*");
    System.out.println( wc.match("aa") );
    
  }
}
