/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * ExceptionUtils.java
 *
 * Created on 03 March 2007 Saturday, 20:27
 *
 */

package org.moremotion.exception;

import java.io.PrintWriter;
import java.io.StringWriter;
import org.moremotion.util.XString;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: ExceptionUtils.java 108 2008-03-25 11:03:29Z erkan $
 */

public class ExceptionUtils {
  

  public static String getStackTrace(Exception originalException) {
    String details = null;
    
    if (originalException != null) {
      StringWriter sw = new StringWriter();
      PrintWriter pw = new PrintWriter(sw);
      
      if (originalException instanceof MoreMotionException) {
        ((MoreMotionException)originalException).printStackTrace(pw);
      } else {
        originalException.printStackTrace(pw);
      }
      pw.close();
      details = sw.toString();
      details = XString.beforeLast(details,"org.moremotion.servlet.JspFilter");
      int x = details.lastIndexOf("org.moremotion");
      if (x > -1) {
        x = details.indexOf("\r\n",x+10);
        if (x > 0) details = details.substring(0,x);
      }
    }
    return details;
  }
  
}
