/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * RecordStatus.java
 *
 * Created on 01 August 2007 Wednesday, 17:50
 *
 */

package org.moremotion.process;

import org.moremotion.util.XString;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: RecordStatus.java 51 2008-03-10 11:46:54Z erkan $
 */
public class RecordStatus {
  
  private String str;
  private String[] modifiedFields = new String[0];
  private boolean isSelected = false;
  private String parentRecNum = "";
  
  /** Creates a new instance of RecordStatus */
  public RecordStatus(String str) {
    
    this.str = str;
    if (str != null && str.length() > 0) {
      String[] values = XString.split(str,';');
      if (values.length > 0) this.modifiedFields = XString.split(values[0],' ');
      if (values.length > 1) this.isSelected = values[1].equals("true");
      if (values.length > 2) this.parentRecNum = values[2];
    }
    
  }
  
  public boolean isModified() {
    return this.modifiedFields.length > 0;
  }
  
  public boolean isFieldModified(String fieldName) {
    if (this.modifiedFields.length == 0) return false;
    for (int i = 0; i < this.modifiedFields.length; i++) {
      if (fieldName.equals(this.modifiedFields[i])) {
        return true;
      }
    }
    return false;
  }
  
  public boolean isSelected() {
    return this.isSelected;
  }
  
  public String[] getModifiedFields() {
    return this.modifiedFields;
  }
  
  public String getModifiedFieldsAsString() {
    return XString.before(this.str,';');
  }
  
  public String getParentRecNum() {
    return this.parentRecNum;
  }
  
  public String toString() {
    return this.str;
  };
  
}
