/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * DefaultEncryptor.java
 *
 * Created on 17 January 2007 Wednesday, 23:25
 */

package org.moremotion.security;

import org.moremotion.util.Encryption;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: DefaultEncryptor.java 51 2008-03-10 11:46:54Z erkan $
 */
public class DefaultEncryptor implements Encryptor { 
  
  public String encrypt(String str, String key) {
    if (key == null) {
      return Encryption.encrypt(str, 10, 52845, 11719, 133);
    } else {
      return Encryption.encstr(str,key);
    }
  }
  
  public String decrypt(String str, String key) throws DecryptionException {
    String result = null;
    if (key == null) {
      result = Encryption.decrypt(str, 10, 52845, 11719, 133);
    } else {
      result = Encryption.decstr(str,key);
    }
    if (result.equals("DECRYPT_ERROR!")) {
      throw new DecryptionException();
    }
    return result;
  }
  
  public String oneWayEncrypt(String str) {
    str = (str + str.length() + str).hashCode() + " .";
    str = (str + str.length() + str).hashCode() + " .";
    return str;
  }
  
  public boolean isEncrypted(String str, String key) {
    if (str.endsWith(" .")) return true;
    try {
      decrypt(str,key);
      return true;
    } catch(Exception e) {
      return false;
    }
  }
  

}
