/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * XString.java
 *
 * Created on 07 August 2007 Tuesday, 19:45
 *
 */

package org.moremotion.util;

import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: XString.java 93 2008-03-23 15:50:32Z erkan $
 */
public class XString {
  
  private String s = null;
  private int loc = -1;
  
  /** Creates a new instance of XString */
  public XString(String s) {
    this.s = s;
  }

  
  public static String after(String s, String dlm) {
    if (s == null) return null;
    int x = s.indexOf(dlm);
    if (x == -1) return s;
    return s.substring(x+dlm.length());
  }
  
  public static String after(String s, String dlm, String def) {
    if (s == null) return def;
    int x = s.indexOf(dlm);
    if (x == -1) return def;
    return s.substring(x+dlm.length());
  }
  
  public static String after(String s, char dlm) {
    if (s == null) return null;
    int x = s.indexOf(dlm);
    if (x == -1) return s;
    return s.substring(x+1);
  }
  
  public static String after(String s, char dlm, String def) {
    if (s == null) return def;
    int x = s.indexOf(dlm);
    if (x == -1) return def;
    return s.substring(x+1);
  }
  
  public static String afterLast(String s, String dlm) {
    if (s == null) return null;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return s;
    return s.substring(x+dlm.length());
  }
  
  public static String afterLast(String s, String dlm, String def) {
    if (s == null) return def;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return def;
    return s.substring(x+dlm.length());
  }
  
  public static String afterLast(String s, char dlm) {
    if (s == null) return null;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return s;
    return s.substring(x+1);
  }
  
  public static String afterLast(String s, char dlm, String def) {
    if (s == null) return def;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return def;
    return s.substring(x+1);
  }
  
  public static String before(String s, String dlm) {
    if (s == null) return null;
    int x = s.indexOf(dlm);
    if (x == -1) return s;
    return s.substring(0,x);
  }
  
  public static String before(String s, String dlm, String def) {
    if (s == null) return def;
    int x = s.indexOf(dlm);
    if (x == -1) return def;
    return s.substring(0,x);
  }
  
  public static String before(String s, char dlm) {
    if (s == null) return null;
    int x = s.indexOf(dlm);
    if (x == -1) return s;
    return s.substring(0,x);
  }
  
  public static String before(String s, char dlm, String def) {
    if (s == null) return def;
    int x = s.indexOf(dlm);
    if (x == -1) return def;
    return s.substring(0,x);
  }
  
  public static String beforeLast(String s, String dlm) {
    if (s == null) return null;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return s;
    return s.substring(0,x);
  }
  
  public static String beforeLast(String s, String dlm, String def) {
    if (s == null) return def;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return def;
    return s.substring(0,x);
  }
  
  public static String beforeLast(String s, char dlm) {
    if (s == null) return null;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return s;
    return s.substring(0,x);
  }
  
  public static String beforeLast(String s, char dlm, String def) {
    if (s == null) return def;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return def;
    return s.substring(0,x);
  }
  
  public static String safe(String s) {
    return s == null ? "" : s;
  }
  
  public static XString create(String s) {
    return new XString(s == null ? "" : s);
  }
  
  public static XString create(String[] sa, String dlm) {
    if (sa == null || sa.length == 0) {
      return new XString("");
    }
    StringBuffer buf = new StringBuffer();
    for (int i = 0; i < sa.length; i++) {
      if (i > 0) buf.append(dlm);
      buf.append(sa[i]);
    }
    return new XString(buf.toString());
  }
  
  public static XString create(String[] sa, char dlm) {
    if (sa == null || sa.length == 0) {
      return new XString("");
    }
    StringBuffer buf = new StringBuffer();
    for (int i = 0; i < sa.length; i++) {
      if (i > 0) buf.append(dlm);
      buf.append(sa[i]);
    }
    return new XString(buf.toString());
  }

  public static String replace(String s, String from, String to) {
    if (s.length() == 0) return s;
    int x = s.indexOf(from);
    if (x == -1) return s;
    StringBuffer buf = new StringBuffer(s.length() + s.length() / 2);
    int cp = 0;
    while (x > -1) {
      buf.append(s.substring(cp,x));
      buf.append(to);
      cp = x + from.length();
      x = s.indexOf(from,cp);
    }
    buf.append(s.substring(cp));
    return buf.toString();
  }
  
  public static String replace(String s, char from, char to) {
    return s.replace(from,to);
  }
  
  public XString after(String dlm) {
    if (dlm == null) return this;
    int x = s.indexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(x + dlm.length()));
  }
  
  public XString after(char dlm) {
    int x = s.indexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(x+1));
  }
  
  public XString afterLast(String dlm) {
    if (dlm == null) return this;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(x + dlm.length()));
  }
  
  public XString afterLast(char dlm) {
    int x = s.lastIndexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(x+1));
  }
  
  public XString before(String dlm) {
    if (dlm == null) return this;
    int x = s.indexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(0,x));
  }
  
  public XString before(char dlm) {
    int x = s.indexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(0,x));
  }
  
  public XString beforeLast(String dlm) {
    if (dlm == null) return this;
    int x = s.lastIndexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(0,x));
  }
  
  public XString beforeLast(char dlm) {
    int x = s.lastIndexOf(dlm);
    if (x == -1) return this;
    return new XString(s.substring(0,x));
  }
  
  public XString appendL(char c) {
    s = c + s;
    return this;
  }
  
  public XString appendR(char c) {
    s = s + c;
    return this;
  }
  
  public XString doubleTheQuotes() {
    replace("'","''");
    return this;
  }
  
  public XString encloseWith(char l, char r) {
    s = l + s + r;
    return this;
  }
  
  public XString encloseWithQuotes() {
    encloseWith('\'','\'');
    return this;
  }
  
  public String s() {
    return s;
  }
  
  public String s(String def) {
    return s.length() == 0 ? def : s;
  }
  
  public static String[] split(String s, String dlm) {
    if (dlm.length() == 1) {
      return split(s, dlm.charAt(0));
    }
    if (s.length() == 0) {
      return new String[0];
    }
    
    ArrayList a = new ArrayList();
    int i = s.indexOf(dlm);
    while(i > -1) {
      a.add(s.substring(0,i));
      s = s.substring(i+dlm.length());
      i = s.indexOf(dlm);
    }
    if (s.length() > 0)  a.add(s);
    String[] result = new String[0];
    if (a.size() != 0) {
      result = new String[a.size()];
      a.toArray(result);
    }
    return result;
  }
  
  public static String[] split(String s, char dlm) {
    return split(s,dlm,false);
  }
  
  public static String[] split(String s, char dlm, boolean trimmed) {
    if (s.length() == 0) {
      return new String[0];
    }
    ArrayList a = splitToArrayList(s,dlm,trimmed);
    if (a.size() > 0) {
      String[] result = new String[a.size()];
      a.toArray(result);
      return result;
    }
    return new String[0];
  }
  
  public static ArrayList splitToArrayList(String s, char dlm, boolean trimmed) {
    ArrayList a = new ArrayList();
    if (s.length() == 0) {
      return a;
    }
    StringParser parser = new StringParser(s,dlm);
    if (trimmed) parser.trimmed();
    while (parser.hasMore()) {
      a.add(parser.nextItem());  
    }
    return a;
  }
  
  public XString trimEnclosers() {
    s = s.trim();
    int lpos = s.length()-1;
    if (lpos > 1) {
      s = s.substring(1,lpos);
    }
    return this;
  }
  
  public StringParser getParser(char dlm) {
    return new StringParser(s,dlm);
  }
  
  public XString replace(String from, String to) {
    this.s = replace(this.s, from, to);
    return this;
  }
  
  public XString replace(char from, char to) {
    this.s = replace(this.s, from, to);
    return this;
  }
  
  public int i() {
    try {
      return Integer.parseInt(s);
    } catch (Exception e) {
      return 0;
    }
  }
  
  public int i(int def) {
    try {
      return Integer.parseInt(s);
    } catch (Exception e) {
      return def;
    }
  }
  
  public boolean b() {
    if (s.equalsIgnoreCase("true")) return true;
    return false;
  }
  
  public boolean b(boolean def) {
    if (s.equalsIgnoreCase("true")) return true;
    if (s.equalsIgnoreCase("false")) return false;
    return def;
  }
  
  public double d() {
    try {
      return Double.parseDouble(s);
    } catch (Exception e) {
      return 0;
    }
  }

  public double d(double def) {
    try {
      return Double.parseDouble(s);
    } catch (Exception e) {
      return def;
    }
  }

  public static void main(String[] args) throws Exception {
    String[] strs = XString.split("AYCAN%BAYCAN%%%ERKAN%%MERKAN","%%%"); 
    System.out.println(strs[0]);
  }
  
  
  
  
}

