/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * Debug.java
 *
 * Created on July 13, 2003, 6:07 PM
 */

package org.moremotion.utilityservices;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;
import java.util.Enumeration;

import org.moremotion.action.ActionService;
import org.moremotion.action.ActionServiceContext;
import org.moremotion.servlet.ServiceException;
import org.moremotion.servlet.MoreMotionRequest;

/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: Debug.java 186 2008-07-31 18:23:46Z erkan $
 */
public class Debug implements ActionService {

  public void doService(ActionServiceContext asc) throws ServiceException, IOException {
    
    MoreMotionRequest request = asc.getRequest();
    
    Enumeration e = request.getParameterNames();
    while(e.hasMoreElements()) {
      String unit = (String) e.nextElement();
      String value = request.getParameter(unit);

      if (value == null || value.equals("")) value = "0";
      else if (value.equalsIgnoreCase("off")) value = "0";
      else if (value.equalsIgnoreCase("on")) value = "3";
      else if (value.equals("1")) value = "1";
      else if (value.equals("2")) value = "2";
      else if (value.equals("3")) value = "3";
      else value = "0";

      HttpSession ses = request.getSession();
      String swname = "__debugswitch_" + unit;
      ses.setAttribute(swname,value);

      request.setNoCache();
      HttpServletResponse response = request.getResponse();
      response.setContentType("text/html");
      java.io.PrintWriter out = response.getWriter();
      out.println("<html><body>Debug level of '"+unit+"' set to "+value+"</body></html>");
      out.close();
    }
  }

}
