/*
 *********************************************************************************
 *                                                                               *
 *  MoreMotion Application Framework                                             *
 *                                                                               * 
 *  Copyright (C) 2002-2008 MOR YAZILIM, (http://www.moryazilim.com)             *
 *                                                                               *
 *  This file is a part of MoreMotion Application Framework                      *
 *                                                                               *
 *  MoreMotion Application Framework is free software: you can redistribute      * 
 *  it and/or modify it under the terms of the GNU Lesser Genaral Public License * 
 *  as published by the Free Software Foundation, either version 3 of the        *
 *  License, or (at your option) any later version.                              *
 *                                                                               *
 *  MoreMotion Application Framework is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 *  GNU General Public License for more details.                                 *
 *                                                                               *
 *  You should have received a copy of the GNU Lesser General Public License     *
 *  along with MoreMotion Application Framework.                                 * 
 *  If not, see http://www.gnu.org/licenses/lgpl.txt                             *
 *                                                                               *
 *********************************************************************************
 */

/*
 * SetAttribute.java
 *
 * Created on July 13, 2003, 6:07 PM
 */

package org.moremotion.utilityservices;

import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.Enumeration;
import org.moremotion.action.ActionServiceContext;
import org.moremotion.page.PageGenerationException;
import org.moremotion.action.ActionService;
import org.moremotion.servlet.MoreMotionRequest;
import org.moremotion.servlet.ServiceException;


/**
 * @author Erkan Cengiz (erkan.cengiz@moryazilim.com)
 * @version $Id: SetAttribute.java 51 2008-03-10 11:46:54Z erkan $
 */
public class SetAttribute implements ActionService {

  public void doService(ActionServiceContext asc) throws ServiceException, IOException {
    
    MoreMotionRequest request = asc.getRequest();
    
    if (!Utils.isUtilityServiceActive(request,"SetAttribute")) return; 
    
    HttpSession ses = request.getSession();
    Enumeration e = request.getParameterNames();
    int maxage = request.getParameterAsInt("cookieage",0);
    while (e.hasMoreElements()) {
      String prm = (String)e.nextElement();
      if (prm.equals("nextpage") || prm.equals("cookieage") || (prm.length() > 1 && prm.substring(0,1).equals("_"))) {}
      else {
        String prmVal = request.getParameter(prm,"");
        ses.setAttribute(prm,prmVal);
        if (maxage > 0) {
          request.setCookieValue(prm,prmVal,maxage);
        }
      }
    }
    String nextpage = request.getParameter("nextpage","index");
    request.generatePage(nextpage);

  }

}
